#! /bin/sh

set -e

version="`dpkg-parsechangelog  | sed -n 's/^Version: \(.*\)/\1/p'`"

while [ $# -ge 1 ]
do
	name="$1"
	shift
	head_name="refs/heads/$name"
	top_base_name="refs/top-bases/$name"
	ver_head_tag="p/heads/$name/$version"
	ver_base_tag="p/bases/$name/$version"

	echo "$head_name -> $ver_head_tag" >&2
	git tag "$ver_head_tag" "$head_name"
	echo "$top_base_name -> $ver_base_tag" >&2
	git tag "$ver_base_tag" "$top_base_name"
done
